#! /usr/bin/perl
# mlform.cgi : edit opt-members.ph / by ML
# Copyright(C) 2001 by Yuh.N
# $Id: mlform.cgi,v 1.1 2001/02/02 15:45:03 yuh Exp $
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
umask(0077);
use CGI;

require "mllib.pl";

$defaultdomain = 'wni.co.jp';

if (-f "$ML_SETTING_ROOT/mlinfo.ph") {
    require "$ML_SETTING_ROOT/mlinfo.ph";
    $mlinfo_loaded = 1;
}

$PIDFILE = "$ML_SETTING_ROOT/mljoin.pid";

$multi_column = 5;
$server_admin = 'yuh@wni.co.jp';

$q = new CGI;
print $q->header(-expires=>now, -title=>'MLjoin');
print $q->start_html(-bgcolor=>'#ffffff');
print "<form action=$ENV{'SCRIPT_NAME'} method=POST>\n";
print '<h1>᡼</h1>',"\n";

if ($q->param('SUBMIT') eq 'Update') {

    $ml = $q->param('MLname');
    $ml =~ y/A-Z/a-z/;

    if (MLconfig_read($ml) eq undef) {
	print "᡼󥰥ꥹ $ml Ϥޤ<br>\n";
	last;
    }

    print '᡼󥰥ꥹ:', "$ml\n";
    print "$mlinfotbl{$ml}" if ($mlinfo_loaded);
    print 'ϰʲƤ˹ޤ<br>', "\n";

    foreach $dlist (@DELIVERLIST) {
	require "$ML_SETTING_ROOT/$ml/$dlist";

	$srcfile = "$ML_SETTING_ROOT/$ml/$dlist";
	$tmpfile = "$ML_SETTING_ROOT/$ml/$dlist.new";
	lock_on($PIDFILE);

	open(ORG, "$srcfile");
	open(NEW, ">$tmpfile");
	while (<ORG>) {
	    if (/^\'([^\']+)/) {
		$mail = $1;
		if ($q->param("chk.$mail")) {
		    print "$mail<br>\n";
		    $x = $members{$mail};

		    printf NEW "\'%s\' => [\'%s\',", $mail, $$x[0];
		    $found = 0;
		    for ($i = 1; $i <= $#$x; $i++) {
			if ($$x[$i] eq $ml) {
			    $found = 1;
			}
			printf NEW "\'%s\',", $$x[$i];
		    }
		    if ($found == 0) {
			printf NEW "\'%s\',", $ml;
		    }
		    print NEW "],\n";
		}
		else {
		    print NEW;
		}
	    }
	    else {
		print NEW;
	    }
	}
	close(NEW);
	close(ORG);

	system("mv -f $srcfile $srcfile.org");
	system("mv -f $tmpfile $srcfile");
	lock_off($PIDFILE);
	
    }


}
elsif ($q->param('SUBMIT') eq 'Accept') {

    $ml = $q->param('MLname');
    $ml =~ y/A-Z/a-z/;

    $pass = $q->param('MLpass');
    $admin = $q->param('MLadmin');

    if ($ml eq "") {
	print "᡼󥰥ꥹ̾ϤƤޤ<br>\n";
	last;
    }

    if ($pass eq "") {
	print "ѥɤϤƤޤ<br>\n";
	last;
    }

    if ($admin eq "") {
	print "̾ϤƤޤ<br>\n";
	last;
    }

    if (MLconfig_read($ml)) {

	#
	# read administrator list for checking password.
	#

	foreach $alist (@ADMINLIST) {
	    require "$ML_SETTING_ROOT/$ml/$alist";
	}

	if ($members{$admin} ne $pass) {
	    print "authentication error.<br>\n";
	    last;
	}

	if ($OPTIMIZED_DELIVERLIST != 1) {
	    print "OPTIMIZED_DELIVERLIST ѤƤޤ<br>\n";
	    last;
	}

	print '᡼󥰥ꥹ:', "$ml\n";
	print "$mlinfotbl{$ml}" if ($mlinfo_loaded);

	#
	# read delivery list
	#

	foreach $dlist (@DELIVERLIST) {
	    require "$ML_SETTING_ROOT/$ml/$dlist";
	}

	$detailed = 0;
	#
	#
	%joined = ();
	%notyet = ();
	foreach $mail (keys %members) {
	    $x = $members{$mail};
	    for ($i = 1; $i <= $#$x; $i++) { 
		if ($x->[$i] eq $ml) {
		    $joined{$mail} = 1;
		}
	    }
	    if (! exists $joined{$mail}) {
		$notyet{$mail} = 1;
	    } 
	}

	# 1st loop, it already joined.

	$n = 0;
	print "<table>\n";
	foreach $mail (sort keys %joined) {
	    if ($mail =~ /\@$defaultdomain/) {
		$m = $`;
	    }
	    else {
		$m = $mail;
	    }
	    print "<tr>\n" if ((($n % $multi_column) == 0) || ($detailed));
	    print "<td>";
	    print "<input type=checkbox name=\"chk.$mail\" CHECKED>$m<br>\n";
	    print "</td>\n";

	    print "</tr>\n" if ((($n % $multi_column) == ($multi_column - 1)) || ($detailed));
	    $n++;
	}
	print "</table>\n";

	# 2nd loop, not yet.

	$n = 0;
	print "<table>\n";
	foreach $mail (sort keys %notyet) {
	    if ($mail =~ /\@$defaultdomain/) {
		$m = $`;
	    }
	    else {
		$m = $mail;
	    }
	    print "<tr>\n" if ((($n % $multi_column) == 0) || ($detailed));
	    print "<td>";
	    print "<input type=checkbox name=\"chk.$mail\">$m<br>\n";
	    print "</td>\n";

	    print "</tr>\n" if ((($n % $multi_column) == ($multi_column - 1)) || ($detailed));
	    $n++;
	}
	print "</table>\n";

	print "<input type=hidden name=MLname value=\"$ml\">\n";
	print "<input type=hidden name=MLadmin value=\"$ml\">\n";
	print "<input type=hidden name=MLpass value=\"$ml\">\n";
	print "<input type=submit name=SUBMIT value=Update>\n";

    }
    else {
	print "᡼󥰥ꥹ $ml Ϥޤ<br>\n";
	last;
    }
}
else {

print << "EOT";
<table>
<tr>
<td>᡼󥰥ꥹ̾</td>
<td><input type=text name=MLname></td>
</tr>
<tr>
<td>ԥ᡼륢ɥ쥹</td>
<td><input type=text name=MLadmin></td>
</tr>
<tr>
<td>ѥ</td>
<td><input type=password name=MLpass></td>
</tr>
</table>
EOT

    print "<input type=submit name=SUBMIT value=Accept>\n";
}



print "</form>\n";
print $q->end_html();
